paOf1           EQU     8
paOf2           EQU     paOf1 +4
paOf3           EQU     paOf2 +4
paOf4           EQU     paOf3 +4

PA1             EQU     <DWord Ptr [ebp+paOf1]>
PA2             EQU     <DWord Ptr [ebp+paOf2]>
PA3             EQU     <DWord Ptr [ebp+paOf3]>
PA4             EQU     <DWord Ptr [ebp+paOf4]>

stOf1           EQU     16
stOf2           EQU     stOf1 +4
stOf3           EQU     stOf2 +4
stOf4           EQU     stOf3 +4
stOf5           EQU     stOf4 +4
stOf6           EQU     stOf5 +4
stOf7           EQU     stOf6 +4
stOf8           EQU     stOf7 +4
stOf9           EQU     stOf8 +4
stOfA           EQU     stOf9 +4
stOfB           EQU     stOfA +4
stOfC           EQU     stOfB +4
stOfD           EQU     stOfC +4
stOfE           EQU     stOfD +4
stOfF           EQU     stOfE +4

stack1          EQU     <DWord Ptr [ebp-stOf1]>
stack2          EQU     <DWord Ptr [ebp-stOf2]>
stack3          EQU     <DWord Ptr [ebp-stOf3]>
stack4          EQU     <DWord Ptr [ebp-stOf4]>
stack5          EQU     <DWord Ptr [ebp-stOf5]>
stack6          EQU     <DWord Ptr [ebp-stOf6]>
stack7          EQU     <DWord Ptr [ebp-stOf7]>
stack8          EQU     <DWord Ptr [ebp-stOf8]>
stack9          EQU     <DWord Ptr [ebp-stOf9]>
stackA          EQU     <DWord Ptr [ebp-stOfA]>
stackB          EQU     <DWord Ptr [ebp-stOfB]>
stackC          EQU     <DWord Ptr [ebp-stOfC]>
stackD          EQU     <DWord Ptr [ebp-stOfD]>
stackE          EQU     <DWord Ptr [ebp-stOfE]>
stackF          EQU     <DWord Ptr [ebp-stOfF]>


mac             MACRO   MacName:req, INT3:=<1>

IF @Instr(1,<MacName>,<SAVE>) GT 0
   IF INT3
                int     3
   ENDIF
                push    ebp
                mov     ebp, esp
                push    ebx
                push    esi
                push    edi


ELSEIF @Instr(1,<MacName>,<RESTSPAX>) GT 0
                lea     esp,[ebp-12]
                pop     edi
                pop     esi
                pop     ebx
                pop     ebp
rest_ret:       ret     16

ELSEIF @Instr(1,<MacName>,<RESTSP>) GT 0
                lea     esp,[ebp-12]
                sbb     eax,eax
                pop     edi
                pop     esi
                pop     ebx
                pop     ebp
rest_ret:       ret     16

ELSEIF @Instr(1,<MacName>,<RESTAX>) GT 0
                pop     edi
                pop     esi
                pop     ebx
                pop     ebp
rest_ret:       ret     16

ELSEIF @Instr(1,<MacName>,<REST>) GT 0
                sbb     eax,eax
                pop     edi
                pop     esi
                pop     ebx
                pop     ebp
rest_ret:       ret     16
ELSE
                .err    <Unknown command <MacName>>
ENDIF
ENDM


